# -*- coding: utf-8 -*-
"""
Created on Mon May 17 17:38:30 2021

@author: wadikhalid
"""

import os

import pandas as pd

import numpy as np

import copy

import networkx as nx


######################################################################################################
####### GET DAMAGE  ##################################################################################
######################################################################################################

def GetDamage(theexcel):

    Dexcel = theexcel
    
    #   need to recreate the graph 
    #   create empty graph
    GD = nx.Graph()
    
    
    #   adding edge labels with road capacity
    DEdges ={}
    DEdges.clear()
    
    #   adding edges on tht empty graph
    for (i,j) in EMyRoute:
        GD.add_edge(i,j)
    
    
    #   getting the dataframe recorded in excel
    #   readdamages is a dataframe  
    readdamages = pd.read_excel(Dexcel, 'damages')
    
    #print(readdamages)
    
    DamageRaw = readdamages.to_dict('list')
    
    #print(DamageRaw)
    
    DamageRawT = [eval(DamageRaw['(i,j)'][drt1].encode("utf-8")) \
                  for drt1 in range(len(DamageRaw['(i,j)']))]
    
    DamageRawV = [int(DamageRaw['pij'][drv1]) for drv1 in range(len(DamageRaw['pij']))]
    
    damages = {DamageRawT[damages1]: DamageRawV[damages1] \
                    for damages1 in range(len(DamageRawT))}


    return(damages)

######################################################################################################
####### END GET DAMAGE  ##############################################################################
######################################################################################################


###########################################################################################################
######################  LOADING ALL INSTANCE AND DAMAGES FILE FROM FOLDERS EXCEL   ########################
###########################################################################################################

#READING EXCEL USING CODES FROM ONLINE FUNCTION

#THIS METHOD IS TAKEN FROM 

#https://stackoverflow.com/questions/54346748/iterate-excel-files-and-output-in-one-folder-in-python
        
#   src is the source folder, where this python file resides in
#   FOR LOADING INSTANCE
#   os.path.abspath(     r'copy path to folder here. replace \ with \\'    )
src = os.path.abspath(r'  copy path to LOAD_INSTANCE NETWORK folder here. replace \ with \\ ')

#   i wanted to filter among all files, only excel for analysis later
wanted = {'.xls', '.xlsx'}

ExcelFiles = []
ExcelFiles[:]=[]

for root, dirs, filenames in os.walk(src, topdown=False):
    for filename in filenames:
        ext = os.path.splitext(filename)[1]
        if ext in wanted and filename not in ExcelFiles:

            ExcelFiles.append(filename)  
            
 
#   FOR LOADING RECORDED DAMAGES
#   os.path.abspath(     r'copy path to folder here. replace \ with \\'    )            
srcD = os.path.abspath(r'  copy path to LOAD_DAMAGE NETWORK folder here. replace \ with \\ ')

#   only xls and xlsx file in the folder is loaded
wantedD = {'.xls', '.xlsx'}

ExcelFilesD = []
ExcelFilesD[:]=[]

for rootD, dirsD, filenamesD in os.walk(srcD, topdown=False):
    for filenameD2 in filenamesD:
        extD = os.path.splitext(filenameD2)[1]
        if extD in wantedD and filenameD2 not in ExcelFilesD:

            ExcelFilesD.append(filenameD2)                     



###########################################################################################################
######################  CHOOSING INSTANCE AND DAMAGE EXCEL   ##############################################
###########################################################################################################            

print('INSTANCE FILES', ExcelFiles)

print('DAMAGE FILES', ExcelFilesD)

'''
('INSTANCE FILES', 
[
'DataD3N8S3_GIT.xlsx', 
'DataD4N11S4_GIT.xlsx', 
'DataD4N30S10_GIT.xlsx', 
'DataD5N13S5_GIT.xlsx', 
'DataD6N16S6_GIT.xlsx', 
'DataD7N18S7_GIT.xlsx', 
'DataD8N20S8_GIT.xlsx', 
'DataD8N22S9_GIT.xlsx', 
'DataD9N25S10_GIT.xlsx', 
'DataD9N30S10_GIT.xlsx'
]


'DAMAGE FILES', 
[
'DataD3N8S3_DAMAGES_GIT.xlsx', 
'DataD4N11S4_DAMAGES_GIT.xlsx', 
'DataD4N30S10_DAMAGES_GIT.xlsx', 
'DataD5N13S5_DAMAGES_GIT.xlsx', 
'DataD6N16S6_DAMAGES_GIT.xlsx', 
'DataD7N18S7_DAMAGES_GIT.xlsx', 
'DataD8N20S8_DAMAGES_GIT.xlsx', 
'DataD8N22S9_DAMAGES_GIT.xlsx', 
'DataD9N25S10_DAMAGES_GIT.xlsx', 
'DataD9N30S10_DAMAGES_GIT.xlsx'
]

'''

PickInstance = ExcelFiles[0]

PickDamage = ExcelFilesD[0]

###########################################################################################################
######################  PATH TO CHOSEN INSTANCE AND DAMAGE EXCEL   ########################################
###########################################################################################################
#   os.path.join(     r'[copy path to folder here. replace \ with \\, remove [ and ] afterwards ]',PickInstance   )
EInstance = os.path.join('   copy path to LOAD_INSTANCE NETWORK folder here. replace \ with \\  ', PickInstance)

#   os.path.join(     r'copy path to folder here. replace \ with \\',PickDamage   )
EDamage = os.path.join('   copy path to LOAD_DAMAGE NETWORK folder here. replace \ with \\  ', PickDamage)       

###########################################################################################################
######################  OBTAIN CHOSEN INSTANCE AND DAMAGE EXCEL IN PYTHON  ################################
###########################################################################################################

Exls= pd.ExcelFile(str(EInstance))  

EDamageExcel= pd.ExcelFile(str(EDamage))  

###########################################################################################################
######################  EPICENTER COORD   #################################################################
###########################################################################################################
Eepicenter1 = pd.read_excel(EDamageExcel, 'epicenter')


###########################################################################################################
######################  OBTAINING # DEPOT, SHELTER, CONNECTING NODES  FROM EXCEL ##########################
###########################################################################################################

Eparam = pd.read_excel(Exls, 'parameter')
            
#   number of vehicle in the excel, 
#EMparam = int(Eparam['M'])

#   set manual number of vehicles
EMparam = 15

#   set manual capacity of vehicles
Q = 50

#   extract number of depots, shelters, connecting nodes
EDparam = int(Eparam['|D|'])
ESparam = int(Eparam['|S|'])
ENparam = int(Eparam['|N|']) 


#   extract road capacity
RCdata = pd.read_excel(Exls, 'RoadCap')

#   extract demands of shelters
Ddata = pd.read_excel(Exls, 'DemandData')


#   extract node coordinate
EdataC = pd.read_excel(Exls, 'dataC')


###########################################################################################################
######################  SETTING # DEPOT, SHELTER, CONNECTING NODES FROM EXCEL #############################
###########################################################################################################

#   set vehicle 
EM = [i for i in range(0,EMparam)]

#   set depots
D = [i for i in range(0, EDparam)]

#   set shelters
S = [i for i in range(EDparam, EDparam + ESparam)]

#   set connecting nodes
N = [i for i in range(EDparam + ESparam, EDparam + ESparam + ENparam)]


#   all nodes, H
H = []
H.extend(D)
H.extend(S)
H.extend(N)


#   Road Capacity data
ER_data = []
for i in range(1, len(S) + len(N) + len(D)+1):
    ER_data.append(list(RCdata[i]))

ERR = np.array(ER_data)
ErExcel = (ERR[:, 0:(len(S) + len(N) + len(D))]).astype(np.int64)

#####################################################
####### WORKING WITH COORDINATE #####################
#####################################################
#   Getting ID
#   Demand data
EC_ID = list(EdataC['i'])
EC_X = list(EdataC['ix'])
EC_Y = list(EdataC['iy'])
ED_data = list(EdataC['wi'])        

Ec_id = np.array(EC_ID)
EidExcel = (Ec_id).astype(np.int64)

Ec_x = np.array(EC_X)
ExExcel = (Ec_x).astype(np.int64)

Ec_y = np.array(EC_Y)
EyExcel = (Ec_y).astype(np.int64)


#   Demand data 
EDD = np.array(ED_data)
EdExcel = (EDD).astype(np.int64)        

#   dic ID -> x,y
ED_ID = {}

ED_ID.clear()

ED_ID = {EidExcel[i]:(ExExcel[i],EyExcel[i]) for i in range(len(EidExcel))}


#   Edges
EMyRoute = [[i,j] for i in H for j in H if ErExcel[i][j]!=0]


#   damages count for each edge
#   Dictionary =>   (edge): damage value
EDamages = GetDamage(EDamageExcel)


#   computing cost matrix
#       cost is assumed to be proportional to distance
#       computed based on euclidean distance
#   computing time delay due to damage on edges
#       we assume constant velocity for vehicle 90km/h
#       time travel is computed based on this assumption

#   init cost matrix
EcExcel = []
EcExcel[:] = []

#print(type(EcExcel))

#   initiating the cost matrix with the road capacity matrix
EcExcel = (copy.deepcopy(ErExcel)).astype(np.float64)

EcExcel.astype(np.float64)

#print(type(EcExcel))


#   init time matrix
ETExcel = []
ETExcel[:] = []          

#   initiating the time matrix with the road capacity matrix 
ETExcel = (copy.deepcopy(ErExcel)).astype(np.float64)

ETExcel.astype(np.float64)


#   computing time and cost matrix

for (i,j) in EMyRoute:
    EcExcel[i][j] = round(np.sqrt((ED_ID[i][0] - ED_ID[j][0])**2 + (ED_ID[i][1] - ED_ID[j][1])**2), 2)        
    

    if EDamages[i,j]:
        ETExcel[i][j] = round(((EcExcel[i][j]/90)*60), 2) + \
        ((round(((EcExcel[i][j]/90)*60), 2))*\
         ((EDamages[i,j])/float(10)))   
                                        
    else:
        ETExcel[i][j] = round(((EcExcel[i][j]/90)*60), 2) 





